SDL_init.h File Reference
`#include <SDL3/SDL_stdinc.h>`
`#include <SDL3/SDL_error.h>`
`#include <SDL3/SDL_events.h>`
`#include <SDL3/SDL_begin_code.h>`
`#include <SDL3/SDL_close_code.h>`
Include dependency graph for SDL_init.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_INIT_AUDIO 0x00000010u
#define | SDL_INIT_VIDEO 0x00000020u
#define | SDL_INIT_JOYSTICK 0x00000200u
#define | SDL_INIT_HAPTIC 0x00001000u
#define | SDL_INIT_GAMEPAD 0x00002000u
#define | SDL_INIT_EVENTS 0x00004000u
#define | SDL_INIT_SENSOR 0x00008000u
#define | SDL_INIT_CAMERA 0x00010000u
#define | SDL_PROP_APP_METADATA_NAME_STRING "SDL.app.metadata.name"
#define | SDL_PROP_APP_METADATA_VERSION_STRING "SDL.app.metadata.version"
#define | SDL_PROP_APP_METADATA_IDENTIFIER_STRING "SDL.app.metadata.identifier"
#define | SDL_PROP_APP_METADATA_CREATOR_STRING "SDL.app.metadata.creator"
#define | SDL_PROP_APP_METADATA_COPYRIGHT_STRING "SDL.app.metadata.copyright"
#define | SDL_PROP_APP_METADATA_URL_STRING "SDL.app.metadata.url"
#define | SDL_PROP_APP_METADATA_TYPE_STRING "SDL.app.metadata.type"

## Typedefs

typedef Uint32 | SDL_InitFlags
typedef SDL_AppResult(* | SDL_AppInit_func) (void **appstate, int argc, char *argv[])
typedef SDL_AppResult(* | SDL_AppIterate_func) (void *appstate)
typedef SDL_AppResult(* | SDL_AppEvent_func) (void *appstate, SDL_Event *event)
typedef void(* | SDL_AppQuit_func) (void *appstate, SDL_AppResult result)
typedef void(* | SDL_MainThreadCallback) (void *userdata)

## Enumerations

enum | SDL_AppResult { SDL_APP_CONTINUE , SDL_APP_SUCCESS , SDL_APP_FAILURE }

## Functions

bool | SDL_Init (SDL_InitFlags flags)
bool | SDL_InitSubSystem (SDL_InitFlags flags)
void | SDL_QuitSubSystem (SDL_InitFlags flags)
SDL_InitFlags | SDL_WasInit (SDL_InitFlags flags)
void | SDL_Quit (void)
bool | SDL_IsMainThread (void)
bool | SDL_RunOnMainThread (SDL_MainThreadCallback callback, void *userdata, bool wait_complete)
bool | SDL_SetAppMetadata (const char *appname, const char *appversion, const char *appidentifier)
bool | SDL_SetAppMetadataProperty (const char *name, const char *value)
const char * | SDL_GetAppMetadataProperty (const char *name)

## Macro Definition Documentation

## SDL_INIT_AUDIO

#define SDL_INIT_AUDIO 0x00000010u

`SDL_INIT_AUDIO` implies `SDL_INIT_EVENTS`

Definition at line 80 of file SDL_init.h.

## SDL_INIT_CAMERA

#define SDL_INIT_CAMERA 0x00010000u

`SDL_INIT_CAMERA` implies `SDL_INIT_EVENTS`

Definition at line 87 of file SDL_init.h.

## SDL_INIT_EVENTS

#define SDL_INIT_EVENTS 0x00004000u

Definition at line 85 of file SDL_init.h.

## SDL_INIT_GAMEPAD

#define SDL_INIT_GAMEPAD 0x00002000u

`SDL_INIT_GAMEPAD` implies `SDL_INIT_JOYSTICK`

Definition at line 84 of file SDL_init.h.

## SDL_INIT_HAPTIC

#define SDL_INIT_HAPTIC 0x00001000u

Definition at line 83 of file SDL_init.h.

## SDL_INIT_JOYSTICK

#define SDL_INIT_JOYSTICK 0x00000200u

`SDL_INIT_JOYSTICK` implies `SDL_INIT_EVENTS`

Definition at line 82 of file SDL_init.h.

## SDL_INIT_SENSOR

#define SDL_INIT_SENSOR 0x00008000u

`SDL_INIT_SENSOR` implies `SDL_INIT_EVENTS`

Definition at line 86 of file SDL_init.h.

## SDL_INIT_VIDEO

#define SDL_INIT_VIDEO 0x00000020u

`SDL_INIT_VIDEO` implies `SDL_INIT_EVENTS`, should be initialized on the main thread

Definition at line 81 of file SDL_init.h.

## SDL_PROP_APP_METADATA_COPYRIGHT_STRING

#define SDL_PROP_APP_METADATA_COPYRIGHT_STRING "SDL.app.metadata.copyright"

Definition at line 464 of file SDL_init.h.

## SDL_PROP_APP_METADATA_CREATOR_STRING

#define SDL_PROP_APP_METADATA_CREATOR_STRING "SDL.app.metadata.creator"

Definition at line 463 of file SDL_init.h.

## SDL_PROP_APP_METADATA_IDENTIFIER_STRING

#define SDL_PROP_APP_METADATA_IDENTIFIER_STRING "SDL.app.metadata.identifier"

Definition at line 462 of file SDL_init.h.

## SDL_PROP_APP_METADATA_NAME_STRING

#define SDL_PROP_APP_METADATA_NAME_STRING "SDL.app.metadata.name"

Definition at line 460 of file SDL_init.h.

## SDL_PROP_APP_METADATA_TYPE_STRING

#define SDL_PROP_APP_METADATA_TYPE_STRING "SDL.app.metadata.type"

Definition at line 466 of file SDL_init.h.

## SDL_PROP_APP_METADATA_URL_STRING

#define SDL_PROP_APP_METADATA_URL_STRING "SDL.app.metadata.url"

Definition at line 465 of file SDL_init.h.

## SDL_PROP_APP_METADATA_VERSION_STRING

#define SDL_PROP_APP_METADATA_VERSION_STRING "SDL.app.metadata.version"

Definition at line 461 of file SDL_init.h.

## Typedef Documentation

## SDL_AppEvent_func

typedef SDL_AppResult(* SDL_AppEvent_func) (void *appstate, SDL_Event *event)

Function pointer typedef for SDL_AppEvent.

These are used by SDL_EnterAppMainCallbacks. This mechanism operates behind the scenes for apps using the optional main callbacks. Apps that want to use this should just implement SDL_AppEvent directly.

Parameters

  appstate | an optional pointer, provided by the app in SDL_AppInit.
  event | the new event for the app to examine.

Returns
  SDL_APP_FAILURE to terminate with an error, SDL_APP_SUCCESS to terminate with success, SDL_APP_CONTINUE to continue.

Since
  This datatype is available since SDL 3.2.0.

Definition at line 164 of file SDL_init.h.

## SDL_AppInit_func

typedef SDL_AppResult(* SDL_AppInit_func) (void **appstate, int argc, char *argv[])

Function pointer typedef for SDL_AppInit.

These are used by SDL_EnterAppMainCallbacks. This mechanism operates behind the scenes for apps using the optional main callbacks. Apps that want to use this should just implement SDL_AppInit directly.

Parameters

  appstate | a place where the app can optionally store a pointer for future use.
  argc | the standard ANSI C main's argc; number of elements in `argv`.
  argv | the standard ANSI C main's argv; array of command line arguments.

Returns
  SDL_APP_FAILURE to terminate with an error, SDL_APP_SUCCESS to terminate with success, SDL_APP_CONTINUE to continue.

Since
  This datatype is available since SDL 3.2.0.

Definition at line 133 of file SDL_init.h.

## SDL_AppIterate_func

typedef SDL_AppResult(* SDL_AppIterate_func) (void *appstate)

Function pointer typedef for SDL_AppIterate.

These are used by SDL_EnterAppMainCallbacks. This mechanism operates behind the scenes for apps using the optional main callbacks. Apps that want to use this should just implement SDL_AppIterate directly.

Parameters

  appstate | an optional pointer, provided by the app in SDL_AppInit.

Returns
  SDL_APP_FAILURE to terminate with an error, SDL_APP_SUCCESS to terminate with success, SDL_APP_CONTINUE to continue.

Since
  This datatype is available since SDL 3.2.0.

Definition at line 148 of file SDL_init.h.

## SDL_AppQuit_func

typedef void(* SDL_AppQuit_func) (void *appstate, SDL_AppResult result)

Function pointer typedef for SDL_AppQuit.

These are used by SDL_EnterAppMainCallbacks. This mechanism operates behind the scenes for apps using the optional main callbacks. Apps that want to use this should just implement SDL_AppEvent directly.

Parameters

  appstate | an optional pointer, provided by the app in SDL_AppInit.
  result | the result code that terminated the app (success or failure).

Since
  This datatype is available since SDL 3.2.0.

Definition at line 178 of file SDL_init.h.

## SDL_InitFlags

typedef Uint32 SDL_InitFlags

# CategoryInit

All SDL programs need to initialize the library before starting to work with it.

Almost everything can simply call SDL_Init() near startup, with a handful of flags to specify subsystems to touch. These are here to make sure SDL does not even attempt to touch low-level pieces of the operating system that you don't intend to use. For example, you might be using SDL for video and input but chose an external library for audio, and in this case you would just need to leave off the `SDL_INIT_AUDIO` flag to make sure that external library has complete control.

Most apps, when terminating, should call SDL_Quit(). This will clean up (nearly) everything that SDL might have allocated, and crucially, it'll make sure that the display's resolution is back to what the user expects if you had previously changed it for your game.

SDL3 apps are strongly encouraged to call SDL_SetAppMetadata() at startup to fill in details about the program. This is completely optional, but it helps in small ways (we can provide an About dialog box for the macOS menu, we can name the app in the system's audio mixer, etc). Those that want to provide a lot of information should look at the more-detailed SDL_SetAppMetadataProperty(). Initialization flags for SDL_Init and/or SDL_InitSubSystem

These are the flags which may be passed to SDL_Init(). You should specify the subsystems which you will be using in your application.

Since
  This datatype is available since SDL 3.2.0.

See also
  SDL_Init
  SDL_Quit
  SDL_InitSubSystem
  SDL_QuitSubSystem
  SDL_WasInit

Definition at line 78 of file SDL_init.h.

## SDL_MainThreadCallback

typedef void(* SDL_MainThreadCallback) (void *userdata)

Callback run on the main thread.

Parameters

  userdata | an app-controlled pointer that is passed to the callback.

Since
  This datatype is available since SDL 3.2.0.

See also
  SDL_RunOnMainThread

Definition at line 331 of file SDL_init.h.

## Enumeration Type Documentation

## SDL_AppResult

enum SDL_AppResult

Return values for optional main callbacks.

Returning SDL_APP_SUCCESS or SDL_APP_FAILURE from SDL_AppInit, SDL_AppEvent, or SDL_AppIterate will terminate the program and report success/failure to the operating system. What that means is platform-dependent. On Unix, for example, on success, the process error code will be zero, and on failure it will be 1. This interface doesn't allow you to return specific exit codes, just whether there was an error generally or not.

Returning SDL_APP_CONTINUE from these functions will let the app continue to run.

See Main callbacks in SDL3 for complete details.

Since
  This enum is available since SDL 3.2.0.

Enumerator
SDL_APP_CONTINUE | Value that requests that the app continue from the main callbacks.
SDL_APP_SUCCESS | Value that requests termination with success from the main callbacks.
SDL_APP_FAILURE | Value that requests termination with error from the main callbacks.

Definition at line 109 of file SDL_init.h.

{
SDL_APP_CONTINUE, /**< Value that requests that the app continue from the main callbacks. */
SDL_APP_SUCCESS, /**< Value that requests termination with success from the main callbacks. */
SDL_APP_FAILURE /**< Value that requests termination with error from the main callbacks. */
} SDL_AppResult;
SDL_AppResult
SDL_AppResult
Definition SDL_init.h:110
SDL_APP_CONTINUE
@ SDL_APP_CONTINUE
Definition SDL_init.h:111
SDL_APP_SUCCESS
@ SDL_APP_SUCCESS
Definition SDL_init.h:112
SDL_APP_FAILURE
@ SDL_APP_FAILURE
Definition SDL_init.h:113

## Function Documentation

## SDL_GetAppMetadataProperty()

const char * SDL_GetAppMetadataProperty | ( | const char * | name | ) |

extern

Get metadata about your app.

This returns metadata previously set using SDL_SetAppMetadata() or SDL_SetAppMetadataProperty(). See SDL_SetAppMetadataProperty() for the list of available properties and their meanings.

Parameters

  name | the name of the metadata property to get.

Returns
  the current value of the metadata property, or the default if it is not set, NULL for properties with no default.

\threadsafety It is safe to call this function from any thread, although the string returned is not protected and could potentially be freed if you call SDL_SetAppMetadataProperty() to set that property from another thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetAppMetadata
  SDL_SetAppMetadataProperty

## SDL_Init()

bool SDL_Init | ( | SDL_InitFlags | flags | ) |

extern

Initialize the SDL library.

SDL_Init() simply forwards to calling SDL_InitSubSystem(). Therefore, the two may be used interchangeably. Though for readability of your code SDL_InitSubSystem() might be preferred.

The file I/O (for example: SDL_IOFromFile) and threading (SDL_CreateThread) subsystems are initialized by default. Message boxes (SDL_ShowSimpleMessageBox) also attempt to work without initializing the video subsystem, in hopes of being useful in showing an error dialog when SDL_Init fails. You must specifically initialize other subsystems if you use them in your application.

Logging (such as SDL_Log) works without initialization, too.

`flags` may be any of the following OR'd together:

- `SDL_INIT_AUDIO`: audio subsystem; automatically initializes the events subsystem
- `SDL_INIT_VIDEO`: video subsystem; automatically initializes the events subsystem, should be initialized on the main thread.
- `SDL_INIT_JOYSTICK`: joystick subsystem; automatically initializes the events subsystem
- `SDL_INIT_HAPTIC`: haptic (force feedback) subsystem
- `SDL_INIT_GAMEPAD`: gamepad subsystem; automatically initializes the joystick subsystem
- `SDL_INIT_EVENTS`: events subsystem
- `SDL_INIT_SENSOR`: sensor subsystem; automatically initializes the events subsystem
- `SDL_INIT_CAMERA`: camera subsystem; automatically initializes the events subsystem

Subsystem initialization is ref-counted, you must call SDL_QuitSubSystem() for each SDL_InitSubSystem() to correctly shutdown a subsystem manually (or call SDL_Quit() to force shutdown). If a subsystem is already loaded then this call will increase the ref-count and return.

Consider reporting some basic metadata about your application before calling SDL_Init, using either SDL_SetAppMetadata() or SDL_SetAppMetadataProperty().

Parameters

  flags | subsystem initialization flags.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetAppMetadata
  SDL_SetAppMetadataProperty
  SDL_InitSubSystem
  SDL_Quit
  SDL_SetMainReady
  SDL_WasInit

## SDL_InitSubSystem()

bool SDL_InitSubSystem | ( | SDL_InitFlags | flags | ) |

extern

Compatibility function to initialize the SDL library.

This function and SDL_Init() are interchangeable.

Parameters

  flags | any of the flags used by SDL_Init(); see SDL_Init for details.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_Init
  SDL_Quit
  SDL_QuitSubSystem

## SDL_IsMainThread()

bool SDL_IsMainThread | ( | void |  | ) |

extern

Return whether this is the main thread.

On Apple platforms, the main thread is the thread that runs your program's main() entry point. On other platforms, the main thread is the one that calls SDL_Init(SDL_INIT_VIDEO), which should usually be the one that runs your program's main() entry point. If you are using the main callbacks, SDL_AppInit(), SDL_AppIterate(), and SDL_AppQuit() are all called on the main thread.

Returns
  true if this thread is the main thread, or false otherwise.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RunOnMainThread

## SDL_Quit()

void SDL_Quit | ( | void |  | ) |

extern

Clean up all initialized subsystems.

You should call this function even if you have already shutdown each initialized subsystem with SDL_QuitSubSystem(). It is safe to call this function even in the case of errors in initialization.

You can use this function with atexit() to ensure that it is run when your application is shutdown, but it is not wise to do this from a library or other dynamically loaded code.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_Init
  SDL_QuitSubSystem

## SDL_QuitSubSystem()

void SDL_QuitSubSystem | ( | SDL_InitFlags | flags | ) |

extern

Shut down specific SDL subsystems.

You still need to call SDL_Quit() even if you close all open subsystems with SDL_QuitSubSystem().

Parameters

  flags | any of the flags used by SDL_Init(); see SDL_Init for details.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_InitSubSystem
  SDL_Quit

## SDL_RunOnMainThread()

bool SDL_RunOnMainThread | ( | SDL_MainThreadCallback | callback,
|  | void * | userdata,
|  | bool | wait_complete
| ) |  |

extern

Call a function on the main thread during event processing.

If this is called on the main thread, the callback is executed immediately. If this is called on another thread, this callback is queued for execution on the main thread during event processing.

Be careful of deadlocks when using this functionality. You should not have the main thread wait for the current thread while this function is being called with `wait_complete` true.

Parameters

  callback | the callback to call on the main thread.
  userdata | a pointer that is passed to `callback`.
  wait_complete | true to wait for the callback to complete, false to return immediately.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_IsMainThread

## SDL_SetAppMetadata()

bool SDL_SetAppMetadata | ( | const char * | appname,
|  | const char * | appversion,
|  | const char * | appidentifier
| ) |  |

extern

Specify basic metadata about your app.

You can optionally provide metadata about your app to SDL. This is not required, but strongly encouraged.

There are several locations where SDL can make use of metadata (an "About" box in the macOS menu bar, the name of the app can be shown on some audio mixers, etc). Any piece of metadata can be left as NULL, if a specific detail doesn't make sense for the app.

This function should be called as early as possible, before SDL_Init. Multiple calls to this function are allowed, but various state might not change once it has been set up with a previous call to this function.

Passing a NULL removes any previous metadata.

This is a simplified interface for the most important information. You can supply significantly more detailed metadata with SDL_SetAppMetadataProperty().

Parameters

  appname | The name of the application ("My Game 2: Bad Guy's Revenge!").
  appversion | The version of the application ("1.0.0beta5" or a git hash, or whatever makes sense).
  appidentifier | A unique string in reverse-domain format that identifies this app ("com.example.mygame2").

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetAppMetadataProperty

## SDL_SetAppMetadataProperty()

bool SDL_SetAppMetadataProperty | ( | const char * | name,
|  | const char * | value
| ) |  |

extern

Specify metadata about your app through a set of properties.

You can optionally provide metadata about your app to SDL. This is not required, but strongly encouraged.

There are several locations where SDL can make use of metadata (an "About" box in the macOS menu bar, the name of the app can be shown on some audio mixers, etc). Any piece of metadata can be left out, if a specific detail doesn't make sense for the app.

This function should be called as early as possible, before SDL_Init. Multiple calls to this function are allowed, but various state might not change once it has been set up with a previous call to this function.

Once set, this metadata can be read using SDL_GetAppMetadataProperty().

These are the supported properties:

- `SDL_PROP_APP_METADATA_NAME_STRING`: The human-readable name of the application, like "My Game 2: Bad Guy's Revenge!". This will show up anywhere the OS shows the name of the application separately from window titles, such as volume control applets, etc. This defaults to "SDL Application".
- `SDL_PROP_APP_METADATA_VERSION_STRING`: The version of the app that is running; there are no rules on format, so "1.0.3beta2" and "April 22nd, 2024" and a git hash are all valid options. This has no default.
- `SDL_PROP_APP_METADATA_IDENTIFIER_STRING`: A unique string that identifies this app. This must be in reverse-domain format, like "com.example.mygame2". This string is used by desktop compositors to identify and group windows together, as well as match applications with associated desktop settings and icons. If you plan to package your application in a container such as Flatpak, the app ID should match the name of your Flatpak container as well. This has no default.
- `SDL_PROP_APP_METADATA_CREATOR_STRING`: The human-readable name of the creator/developer/maker of this app, like "MojoWorkshop, LLC"
- `SDL_PROP_APP_METADATA_COPYRIGHT_STRING`: The human-readable copyright notice, like "Copyright (c) 2024 MojoWorkshop, LLC" or whatnot. Keep this to one line, don't paste a copy of a whole software license in here. This has no default.
- `SDL_PROP_APP_METADATA_URL_STRING`: A URL to the app on the web. Maybe a product page, or a storefront, or even a GitHub repository, for user's further information This has no default.
- `SDL_PROP_APP_METADATA_TYPE_STRING`: The type of application this is. Currently this string can be "game" for a video game, "mediaplayer" for a media player, or generically "application" if nothing else applies. Future versions of SDL might add new types. This defaults to "application".

Parameters

  name | the name of the metadata property to set.
  value | the value of the property, or NULL to remove that property.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetAppMetadataProperty
  SDL_SetAppMetadata

## SDL_WasInit()

SDL_InitFlags SDL_WasInit | ( | SDL_InitFlags | flags | ) |

extern

Get a mask of the specified subsystems which are currently initialized.

Parameters

  flags | any of the flags used by SDL_Init(); see SDL_Init for details.

Returns
  a mask of all initialized subsystems if `flags` is 0, otherwise it returns the initialization status of the specified subsystems.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_Init
  SDL_InitSubSystem